# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetTemDomainResult',
    'AwaitableGetTemDomainResult',
    'get_tem_domain',
    'get_tem_domain_output',
]

@pulumi.output_type
class GetTemDomainResult:
    """
    A collection of values returned by getTemDomain.
    """
    def __init__(__self__, created_at=None, dkim_config=None, domain_id=None, id=None, last_error=None, last_valid_at=None, name=None, next_check_at=None, project_id=None, region=None, revoked_at=None, spf_config=None, status=None):
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if dkim_config and not isinstance(dkim_config, str):
            raise TypeError("Expected argument 'dkim_config' to be a str")
        pulumi.set(__self__, "dkim_config", dkim_config)
        if domain_id and not isinstance(domain_id, str):
            raise TypeError("Expected argument 'domain_id' to be a str")
        pulumi.set(__self__, "domain_id", domain_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_error and not isinstance(last_error, str):
            raise TypeError("Expected argument 'last_error' to be a str")
        pulumi.set(__self__, "last_error", last_error)
        if last_valid_at and not isinstance(last_valid_at, str):
            raise TypeError("Expected argument 'last_valid_at' to be a str")
        pulumi.set(__self__, "last_valid_at", last_valid_at)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if next_check_at and not isinstance(next_check_at, str):
            raise TypeError("Expected argument 'next_check_at' to be a str")
        pulumi.set(__self__, "next_check_at", next_check_at)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if revoked_at and not isinstance(revoked_at, str):
            raise TypeError("Expected argument 'revoked_at' to be a str")
        pulumi.set(__self__, "revoked_at", revoked_at)
        if spf_config and not isinstance(spf_config, str):
            raise TypeError("Expected argument 'spf_config' to be a str")
        pulumi.set(__self__, "spf_config", spf_config)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        The date and time of the Transaction Email Domain's creation (RFC 3339 format).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="dkimConfig")
    def dkim_config(self) -> str:
        """
        The DKIM public key, as should be recorded in the DNS zone.
        """
        return pulumi.get(self, "dkim_config")

    @property
    @pulumi.getter(name="domainId")
    def domain_id(self) -> Optional[str]:
        return pulumi.get(self, "domain_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastError")
    def last_error(self) -> str:
        """
        The error message if the last check failed.
        """
        return pulumi.get(self, "last_error")

    @property
    @pulumi.getter(name="lastValidAt")
    def last_valid_at(self) -> str:
        """
        The date and time the domain was last found to be valid (RFC 3339 format).
        """
        return pulumi.get(self, "last_valid_at")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nextCheckAt")
    def next_check_at(self) -> str:
        """
        The date and time of the next scheduled check (RFC 3339 format).
        """
        return pulumi.get(self, "next_check_at")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> str:
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="revokedAt")
    def revoked_at(self) -> str:
        """
        The date and time of the revocation of the domain (RFC 3339 format).
        """
        return pulumi.get(self, "revoked_at")

    @property
    @pulumi.getter(name="spfConfig")
    def spf_config(self) -> str:
        """
        The snippet of the SPF record that should be registered in the DNS zone.
        """
        return pulumi.get(self, "spf_config")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The status of the Transaction Email Domain.
        """
        return pulumi.get(self, "status")


class AwaitableGetTemDomainResult(GetTemDomainResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTemDomainResult(
            created_at=self.created_at,
            dkim_config=self.dkim_config,
            domain_id=self.domain_id,
            id=self.id,
            last_error=self.last_error,
            last_valid_at=self.last_valid_at,
            name=self.name,
            next_check_at=self.next_check_at,
            project_id=self.project_id,
            region=self.region,
            revoked_at=self.revoked_at,
            spf_config=self.spf_config,
            status=self.status)


def get_tem_domain(domain_id: Optional[str] = None,
                   name: Optional[str] = None,
                   region: Optional[str] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTemDomainResult:
    """
    Gets information about a transactional email domain.


    :param str name: The domain name.
           Only one of `name` and `id` should be specified.
    :param str region: `region`) The region in which the domain exists.
    """
    __args__ = dict()
    __args__['domainId'] = domain_id
    __args__['name'] = name
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('scaleway:index/getTemDomain:getTemDomain', __args__, opts=opts, typ=GetTemDomainResult).value

    return AwaitableGetTemDomainResult(
        created_at=__ret__.created_at,
        dkim_config=__ret__.dkim_config,
        domain_id=__ret__.domain_id,
        id=__ret__.id,
        last_error=__ret__.last_error,
        last_valid_at=__ret__.last_valid_at,
        name=__ret__.name,
        next_check_at=__ret__.next_check_at,
        project_id=__ret__.project_id,
        region=__ret__.region,
        revoked_at=__ret__.revoked_at,
        spf_config=__ret__.spf_config,
        status=__ret__.status)


@_utilities.lift_output_func(get_tem_domain)
def get_tem_domain_output(domain_id: Optional[pulumi.Input[Optional[str]]] = None,
                          name: Optional[pulumi.Input[Optional[str]]] = None,
                          region: Optional[pulumi.Input[Optional[str]]] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTemDomainResult]:
    """
    Gets information about a transactional email domain.


    :param str name: The domain name.
           Only one of `name` and `id` should be specified.
    :param str region: `region`) The region in which the domain exists.
    """
    ...
